--build file for ezip.e (shrouded)
--contains routines from
--ez_read.e
--ez_write.e
--inc2seq.e
--seq2inc.e
--png.e

include machine.e
include get.e
include file.e
include zinflate.e
include zdata.e
include ez_error.e
include misc.e
include crc32.e
include base128.e  

global constant FN=0,SQ=1,SQB=2
global sequence EZ_FILE,EZ_INFO
EZ_FILE={}  --path of program if bound
EZ_INFO={}

--retrives infomation on an ezip file
--must be called for a new ezip file to use ez_get()
--atomatically called at program startup for bound files
global function ez_info(sequence fname)
integer fn,file_pos,file_length,offset,junk,dat_start
sequence buffer,header,offsets
fn=open(fname,"rb")
if fn=-1 then
EZ_ERROR=14
return {}
end if  --open failed
junk=seek(fn,-1)
file_length=where(fn)
--? file_length
junk=seek(fn,file_length-6)
file_pos=file_length-6
buffer=get_bytes(fn,6)

if not(equal(buffer[5..6],"DE")) then
EZ_ERROR=15
close(fn)
return {}
end if
offset=bytes_to_int(buffer[1..4])  
dat_start= file_pos-offset
--close(fn)
junk=seek(fn,dat_start)
buffer=get_bytes(fn,2)
if not(equal(buffer,"DS")) then
EZ_ERROR=15
close(fn) 
return {}
end if
header={}

while 1 do
offsets={}
offset=getc(fn) 
if offset=-1 then 
EZ_ERROR=16
close(fn) 
return {}
end if
if offset=0 then exit end if
buffer=get_bytes(fn,offset+9)
file_pos=where(fn)-9
offsets&=file_pos  --offset
offsets&=buffer[length(buffer)-8] --ctype
offsets&=bytes_to_int(buffer[length(buffer)-7..length(buffer)-4])  --uncompressed
offset=bytes_to_int(buffer[length(buffer)-3..length(buffer)])  --compressed
offsets&=offset
buffer=buffer[1..length(buffer)-9]  --filename
buffer={buffer}
buffer=append(buffer,offsets)
header=append(header,buffer)
junk=seek(fn,file_pos+offset+9)
end while
close(fn)
EZ_INFO=header
EZ_FILE=fname
EZ_ERROR=0
return header --{{"filename1",{offset1,ctype1,ucomp1,comp1}},
--{"filename2",{offset2,ctype2...
end function

procedure ez_file()  --check a bound file for appended ezip data
sequence commands
commands=command_line()
if equal(commands[1],commands[2]) then
EZ_FILE=commands[2]    
EZ_INFO=ez_info(EZ_FILE)
end if
end procedure 

global function ez_get(sequence dname)  --read ezip data
integer test,fn,junk,offset,compressed,uncompressed,ctype
sequence buffer,output
if EZ_ERROR then
return {}    
end if
if length(EZ_INFO)=0 then
EZ_ERROR=17
return {}
end if
test=0
for c=1 to length(EZ_INFO) do
if equal(dname,EZ_INFO[c][1]) then
test=c
exit
end if
end for
if test then
  fn=open(EZ_FILE,"rb")
  if fn=-1 then
  EZ_ERROR=18
  return {}
  end if  --open failed
  offset=EZ_INFO[test][2][1]
  ctype=EZ_INFO[test][2][2]
  uncompressed=EZ_INFO[test][2][3]
  compressed=EZ_INFO[test][2][4]
  junk=seek(fn,offset)
  buffer=get_bytes(fn,compressed+9)
  output=inflate_seq(buffer)
if  EZ_ERROR then
close(fn)
return {}    
end if
    EZ_ERROR=0
close(fn)
    return  output
else
  EZ_ERROR=19

  return {}  --name not found
end if
end function

global function EZ_READ_ERROR_STRING()
if EZ_ERROR=0 then
return "No errors"
else
return EZ_ERROR_STRING[EZ_ERROR]    
end if
end function

global function EZ_READ_ERROR()
return EZ_ERROR    
end function

global procedure CLEAR_READ_ERROR()
EZ_ERROR=0    
end procedure

ez_file() 

global procedure create_ez_file(sequence zname,sequence inputs,
sequence dnames,sequence ftypes)
--zname - string - name for zipdata file
--inputs - sequence of (filenames or sequences)
--dnames - sequence of (names to access data)
--ftypes - sequence of types (filename)=0 (sequence)=1 (sequence of bytes)=2

integer fn,length_data
sequence data,buffer
if length(dnames)=0 then
dnames=inputs    
end if
length_data=0
buffer="DS"
fn=open(zname,"wb")
if fn=-1 then 
EZ_ERROR=8   --file create error  
return 
end if
puts(fn,buffer)
length_data+=2
for c=1 to length(inputs) do
buffer=(dnames[c])
puts(fn,length(buffer))
puts(fn,buffer)
length_data+=length(buffer)+1
data=deflate_seq(inputs[c],ftypes[c])
--if length(data)=1 then  --deflate error
if EZ_ERROR then  --deflate error
close(fn)
system("del "&zname,2)
return
end if
puts(fn,data) 
length_data+=length(data)
end for
puts(fn,0)  
length_data+=1
buffer=int_to_bytes(length_data)
puts(fn,buffer)  
buffer="DE"
puts(fn,buffer)
close(fn)
EZ_ERROR=0
return  --no error
end procedure


global procedure remove_ez_file(sequence zname,sequence rnames)
sequence test,buffer
integer ok,fn,junk,length_data,offset,fn2,extra
test=ez_info(zname)
fn=open(zname,"rb")
fn2=open("$$$.dd","wb")
length_data=0
buffer="DS"
puts(fn2,buffer)
length_data+=2

for c=1 to length(test) do
ok=1
for cc=1 to length(rnames) do
if equal(rnames[cc],test[c][1]) then
ok=0    
end if

end for
if ok then
offset=test[c][2][1]
extra=length(test[c][1])+1
offset-=extra
junk=seek(fn,offset)
buffer=get_bytes(fn,test[c][2][4]+extra+9)
puts(fn2,buffer)
length_data+=length(buffer)
end if
end for
puts(fn2,0)  
length_data+=1
buffer=int_to_bytes(length_data)
puts(fn2,buffer)  
buffer="DE"
puts(fn2,buffer)
flush(fn2)
close(fn2)
close(fn)
system("del "&zname,2)
system("ren $$$.dd "&zname,2)
end procedure

procedure add_or_update_ez_file(sequence zname,sequence inputs,
sequence dnames,sequence ftypes,integer atype)
--atype 0=add 1=update
sequence test,buffer,data,rnames
integer ok,fn,junk,file_end,length_data
test=ez_info(zname)
if EZ_ERROR then   --zname probably does not exist create file
EZ_ERROR=0
create_ez_file(zname,inputs,dnames,ftypes)
return
else
ok=1
rnames={}
for c=1 to length(dnames) do
for cc=1 to length(test) do
if equal(dnames[c],test[cc][1]) then
ok=0    
rnames=append(rnames,dnames[c])
end if
end for
end for
if not(ok) then
if atype then
remove_ez_file(zname,rnames) --update     
else
EZ_ERROR=22    --dname already exists    --add only
return    
end if
end if
fn=open(zname,"ub")
if fn=-1 then 
EZ_ERROR=21   --file open error  
end if
junk=seek(fn,-1)  
file_end=where(fn)
junk=seek(fn,file_end-6)
buffer=get_bytes(fn,4)
length_data=bytes_to_int(buffer)
length_data-=1 --remove end of data byte
junk=seek(fn,file_end-7)

for c=1 to length(inputs) do
buffer=(dnames[c])
puts(fn,length(buffer))
puts(fn,buffer)
length_data+=length(buffer)+1
data=deflate_seq(inputs[c],ftypes[c])
--if length(data)=1 then  --deflate error
if EZ_ERROR then  --deflate error
close(fn)
system("del "&zname,2)
return
end if
puts(fn,data) 
length_data+=length(data)
end for
puts(fn,0)  
length_data+=1
buffer=int_to_bytes(length_data)
puts(fn,buffer)  
buffer="DE"
puts(fn,buffer)
close(fn)
EZ_ERROR=0
return  --no error
end if    
end procedure

global procedure update_ez_file(sequence zname,sequence inputs,
sequence dnames,sequence ftypes)
add_or_update_ez_file(zname,inputs,dnames,ftypes,1)
end procedure

global procedure add_ez_file(sequence zname,sequence inputs,
sequence dnames,sequence ftypes)
add_or_update_ez_file(zname,inputs,dnames,ftypes,0)
end procedure

global function EZ_WRITE_ERROR_STRING()
if EZ_ERROR=0 then
return "No errors"
else
return EZ_ERROR_STRING[EZ_ERROR]    
end if
end function

global function EZ_WRITE_ERROR()
return EZ_ERROR    
end function

global procedure CLEAR_WRITE_ERROR()
EZ_ERROR=0    
end procedure



global function include_to_seq(sequence inseq)
sequence junk,output
junk=base128_to_bytes(inseq)
output=inflate_seq(junk)    
return output
end function

function seq_to_base128(sequence inseq,integer ftype)
sequence output,junk
junk=deflate_seq(inseq,ftype)
if length(junk)=1 then
return junk
end if
output=bytes_to_base128(junk)
return output
end function

global function seq_to_include(sequence inseq,sequence ename,sequence sname,integer ftype)
sequence junk
integer fn,z
integer num_chunks,last_chunk
integer line_length
line_length=180
junk=seq_to_base128(inseq,ftype)
if length(junk)=1 then
return 1
end if
fn=open(ename,"w")
puts(fn,"include ezip.e\n")
puts(fn,"global sequence "&sname&"\n")
puts(fn,"global sequence temp_"&sname&"\n")

puts(fn,"temp_"&sname&"=\n")
num_chunks=floor(length(junk)/(line_length-3))
last_chunk=length(junk)-(line_length-3)*num_chunks
for c=1 to num_chunks-1 do
puts(fn,"\"")
puts(fn,junk[(c-1)*(line_length-3)+1..(c-1)*(line_length-3)+(line_length-3)])
puts(fn,"\"&\n")  
end for
if last_chunk then
z=num_chunks
puts(fn,"\"")
puts(fn,junk[(z-1)*(line_length-3)+1..(z-1)*(line_length-3)+(line_length-3)])
puts(fn,"\"&\n")  
puts(fn,"\"")
z=num_chunks+1
puts(fn,junk[(z-1)*(line_length-3)+1..(z-1)*(line_length-3)+last_chunk])
puts(fn,"\"\n")  

else
z=num_chunks
puts(fn,"\"")
puts(fn,junk[(z-1)*(line_length-3)+1..(z-1)*(line_length-3)+(line_length-3)])
puts(fn,"\"\n")  

end if
puts(fn,sname&"=include_to_seq(temp_"&sname&")\n")
puts(fn,"temp_"&sname&"={}\n")
close(fn)
return 0
end function


integer fn_input,fn_output
sequence png_sig
png_sig={137,80,78,71,13,10,26,10}
function read_chunk()
sequence chunk_length,chunk_name,chunk_dat,chunk_crc
integer ch_length,crc_ok
chunk_length=get_bytes(fn_input,4)
if length(chunk_length)<4 then
return {32}  -- truncated file
end if
ch_length=bytes_to_int(reverse(chunk_length))
chunk_name=get_bytes(fn_input,4)
if length(chunk_name)<4 then
return {32} --bad chunk name
end if
chunk_dat=get_bytes(fn_input,ch_length)
if length(chunk_dat)<ch_length then
return {32} -- truncated file
end if
chunk_crc=reverse(get_bytes(fn_input,4))
if length(chunk_crc)<4 then
return {32}  --truncated file
end if
crc_ok=compare(crc_32(chunk_name&chunk_dat),chunk_crc)
if not(crc_ok=0) then
return {33}  --bad chunk crc
end if
return {chunk_name,chunk_dat}
end function

function save_chunk(sequence chunk_name,sequence chunk_dat)
sequence chunk_crc,chunk_out,chunk_length
chunk_crc=reverse(crc_32(chunk_name&chunk_dat))
chunk_length=reverse(int_to_bytes(length(chunk_dat)))
chunk_out=chunk_length&chunk_name&chunk_dat&chunk_crc
return chunk_out
end function

procedure save_plte(sequence pal)
sequence pal_out,dat_out
pal_out={}
for c=1 to length(pal) do
pal_out&=pal[c]
end for
dat_out=save_chunk("PLTE",pal_out)
puts(fn_output,dat_out)
end procedure

procedure save_ihdr(sequence image)
sequence ihdr_dat,dat_out
ihdr_dat=reverse(int_to_bytes(length(image[1])))
ihdr_dat&=reverse(int_to_bytes(length(image)))
ihdr_dat&={8,3,0,0,0}
dat_out=save_chunk("IHDR",ihdr_dat)
puts(fn_output,dat_out)
end procedure

function save_idat(sequence image)
sequence idat_comp,dat_out
integer fn_temp
fn_temp=open("idat.tmp","wb")
if fn_temp=-1 then
EZ_ERROR=36
return EZ_ERROR
end if
for c=1 to length(image) do
puts(fn_temp,0)
puts(fn_temp,image[c])
end for
close(fn_temp)
idat_comp=deflate_seq("idat.tmp",0)
if length(idat_comp)=0 then
return EZ_ERROR
end if
idat_comp=idat_comp[10..length(idat_comp)]
--idat_comp={120,156}&idat_comp[1..length(idat_comp)-4]
idat_comp={120,156}&idat_comp

dat_out=save_chunk("IDAT",idat_comp)
system("del idat.tmp",2) 
puts(fn_output,dat_out)
return 0
end function

global function save_png(sequence pal_image,sequence fname)
sequence dat_out
integer test
fn_output=open(fname,"wb")
if fn_output=-1 then
EZ_ERROR=31
return -1
end if
puts(fn_output,png_sig)
save_ihdr(pal_image[2])
save_plte(pal_image[1])
test=save_idat(pal_image[2])
if test then
close(fn_output)
system("del "&fname,2) 
return test
end if
dat_out=save_chunk("IEND",{})
puts(fn_output,dat_out)
close(fn_output)
EZ_ERROR=0
return 0
end function
--            IHDR format
--            Width:              4 bytes
--            Height:             4 bytes
--            Bit depth:          1 byte
--            Color type:         1 byte
--            Compression method: 1 byte
--            Filter method:      1 byte
--            Interlace method:   1 byte

global integer png_width,png_height,png_bits,png_color,png_comp
global integer png_filter,png_interlace
global sequence png_pal,png_image
global integer png_pal_count
procedure ihdr(sequence ihdr_dat)
png_width=bytes_to_int(reverse(ihdr_dat[1..4]))
png_height=bytes_to_int(reverse(ihdr_dat[5..8]))
png_bits=ihdr_dat[9]
png_color=ihdr_dat[10]
png_comp=ihdr_dat[11]
png_filter=ihdr_dat[12]
png_interlace=ihdr_dat[13]
end procedure

procedure open_file(sequence fname)
sequence fsig
fn_input=open(fname,"rb")
if fn_input>0 then
 fsig=get_bytes(fn_input,8)
  if compare(png_sig,fsig)=0 then
EZ_ERROR=0
  else
   close(fn_input)
EZ_ERROR=34  --not a png file
  end if
else
EZ_ERROR=31   --file not found
end if
end procedure

global procedure info_png(sequence fname)
sequence test
open_file(fname)
if EZ_ERROR then
return
end if

while 1 do
test=read_chunk()
if length(test)=1 then
EZ_ERROR=test[1]
exit
end if
if compare(test[1],"IHDR")=0 then
ihdr(test[2])
exit
end if
end while
close(fn_input)
end procedure

global function read_png(sequence fname)
integer offs,offe
sequence temp_line
sequence test,junk,idat
idat={} 
open_file(fname)
if EZ_ERROR then
return EZ_ERROR
end if
while 1 do
test=read_chunk()
if length(test)=1 then 
EZ_ERROR=test[1]
return EZ_ERROR
end if
if compare(test[1],"IEND")=0 then exit end if

if compare(test[1],"IHDR")=0 then
ihdr(test[2])
if png_bits<9 and png_color=3 and png_comp=0 and png_filter=0 and png_interlace=0 then
else
close(fn_input)
EZ_ERROR=35
return EZ_ERROR  --unsupported format
end if
end if
if compare(test[1],"IDAT")=0 then
idat&=test[2]
end if
if compare(test[1],"PLTE")=0 then
png_pal_count=length(test[2])/3
png_pal=repeat({0,0,0},png_pal_count)
offs=1
offe=3
for c=1 to png_pal_count do
png_pal[c]=test[2][offs..offe]
offs+=3
offe+=3
end for
end if
end while
close(fn_input)
junk=inflate(idat[3..length(idat)],(png_width+1)*png_height)
if junk[1] then
EZ_ERROR=junk[1]
return EZ_ERROR
end if     
png_image={}
offs=1
offe=png_width+1
for c=1 to png_height do
temp_line=junk[2][offs..offe]
png_image=append(png_image,temp_line[2..length(temp_line)])
offs+=png_width+1
offe+=png_width+1
end for
return {png_pal,png_image}
end function

global function PNG_ERROR_STRING()
if EZ_ERROR=0 then
return "No errors"
else
return EZ_ERROR_STRING[EZ_ERROR]    
end if
end function

global function PNG_ERROR()
return EZ_ERROR    
end function

global procedure CLEAR_PNG_ERROR()
EZ_ERROR=0    
end procedure

