--basic dos32 GUI - Paul Plummer

include rfont.e
include mouse.e
include get.e
integer highlight,shadow,button_color,txt_color
sequence buttons,timage,size
mouse_events(LEFT_DOWN +LEFT_UP)
buttons={{0,0},{0,0}}

button_color=7
highlight=15
shadow=0
txt_color=0
size={100,30}

global function ismouse()   --checks for presence of mouse
sequence regs
    regs = repeat(0, 10)
    regs[REG_AX] = 0
    regs = dos_interrupt(#33, regs)
if regs[REG_AX]=#FFFF then
return 1  --mouse driver present
else
return 0  --mouse driver not loaded
end if
end function

global function double_image(sequence input)   --2X image expansion
sequence bimage,tmpseq
bimage={}
tmpseq=repeat(0,length(input[1])*2)
for c=1 to length(input) do
for cc=1 to length(input[1]) do
tmpseq[(cc-1)*2+1]=input[c][cc]
tmpseq[(cc-1)*2+2]=input[c][cc]
end for
bimage=append(append(bimage,tmpseq),tmpseq)
end for
return  bimage
end function

--set GUI colors
global procedure set_color(integer bcolor,integer hcolor,integer scolor,integer tcolor)
button_color=bcolor   --color inside button
highlight=hcolor      --color button border highlight
shadow=scolor         --color button border shadow
txt_color=tcolor      --test color
end procedure

--set button size
global procedure set_size(sequence ssize)
size=ssize            --button size
end procedure

global procedure box(integer bcolor,sequence sxy,sequence exy)
--draw_line(bcolor,{{sxy[1],sxy[2]},{exy[1],sxy[2]},{exy[1],
--exy[2]},{sxy[1],exy[2]},{sxy[1],sxy[2]}})
draw_line(bcolor,{sxy,{exy[1],sxy[2]},exy,{sxy[1],exy[2]},sxy})
end procedure

global procedure make_button(integer num,sequence chars,sequence pos)
if num >length(buttons) then
for c=1  to num-length(buttons) do
buttons=append(buttons,{pos,size})    
end for
else
buttons[num]={pos,size} 
end if
timage=build_text_image(chars,txt_color,button_color,0)
box(shadow,pos,pos+size)
draw_line(highlight,{{pos[1]+1,pos[2]+size[2]-2},{pos[1]+1,pos[2]+1},
{pos[1]+size[1]-2,pos[2]+1}})
draw_line(shadow,{{pos[1]+1,pos[2]+size[2]-1},{pos[1]+size[1]-1,
pos[2]+size[2]-1},{pos[1]+size[1]-1,pos[2]+1}})
display_image({pos[1]+floor(size[1]/2-length(chars)/2*8),
pos[2]+floor((size[2]-16)/2)},timage)
end procedure

global procedure make_dim_button(integer num,sequence chars,sequence pos)
if num >length(buttons) then
for c=1  to length(buttons)-num do
buttons=append(buttons,{pos,size})    
end for
else
buttons[num]={pos,size} 
end if
timage=build_text_image(chars,txt_color,button_color,DIMMED)
box(shadow,pos,pos+size) 
draw_line(highlight,{{pos[1]+1,pos[2]+size[2]-2},{pos[1]+1,pos[2]+1},
{pos[1]+size[1]-2,pos[2]+1}})
draw_line(shadow,{{pos[1]+1,pos[2]+size[2]-1},{pos[1]+size[1]-1,
pos[2]+size[2]-1},{pos[1]+size[1]-1,pos[2]+1}})
display_image({pos[1]+floor(size[1]/2-length(chars)/2*8),
pos[2]+floor((size[2]-16)/2)},timage)
end procedure

global procedure button_up(integer num)
sequence bpos,ssize
bpos=buttons[num][1]
ssize=buttons[num][2]
draw_line(highlight,{{bpos[1]+1,bpos[2]+ssize[2]-2},{bpos[1]+1,bpos[2]+1},
{bpos[1]+ssize[1]-2,bpos[2]+1}})
draw_line(shadow,{{bpos[1]+1,bpos[2]+ssize[2]-1},{bpos[1]+ssize[1]-1,
bpos[2]+ssize[2]-1},{bpos[1]+ssize[1]-1,bpos[2]+1}})
end procedure

global procedure button_down(integer num)
sequence bpos,ssize
bpos=buttons[num][1]
ssize=buttons[num][2]
draw_line(shadow,{{bpos[1]+1,bpos[2]+ssize[2]-1},{bpos[1]+1,bpos[2]+1},
{bpos[1]+ssize[1]-1,bpos[2]+1}})
draw_line(highlight,{{bpos[1]+2,bpos[2]+ssize[2]-1},{bpos[1]+ssize[1]-1,
bpos[2]+ssize[2]-1},{bpos[1]+ssize[1]-1,bpos[2]+2}})
end procedure

--waits until a button has been clicked
global procedure wait_button_any()
object mevent
while 1 do
mevent=get_mouse()
if sequence(mevent) then
exit
end if
end while
end procedure

--checks for button clicks
function get_button(sequence bnum,integer btype)
object mevent
sequence button
integer test
test=0
mevent=get_mouse()
if sequence(mevent) then
if mevent[1]=btype then
for c=1 to length(bnum) do
button=buttons[bnum[c]]
if mevent[2]>button[1][1] and mevent[2]<button[1][1]+button[2][1] and
mevent[3]>button[1][2] and mevent[3]<button[1][2]+button[2][2] then
test=bnum[c]
exit
end if
end for
end if
end if
return test
end function

global function check_button(sequence bnum,object mevent)
sequence button
integer test
test=0
if sequence(mevent) then
if mevent[1]=LEFT_DOWN then
for c=1 to length(bnum) do
button=buttons[bnum[c]]
if mevent[2]>button[1][1] and mevent[2]<button[1][1]+button[2][1] and
mevent[3]>button[1][2] and mevent[3]<button[1][2]+button[2][2] then
test=bnum[c]
mouse_pointer(0)
button_down(test)
mouse_pointer(1)
wait_button_any()
mouse_pointer(0)
button_up(test)
mouse_pointer(1)
exit
end if
end for
end if
end if
return test
end function

global function get_button_down(sequence bnum)
return get_button(bnum,LEFT_DOWN)
end function


global function wait_button_down(sequence bnum)
integer test
while 1 do
test=get_button_down(bnum)
if test>0 then exit end if
end while
mouse_pointer(0)
button_down(test)
mouse_pointer(1)
wait_button_any()
mouse_pointer(0)
button_up(test)
mouse_pointer(1)
return test
end function


global function mbox(sequence pos,sequence bsize,sequence message,
sequence bnum,sequence labels)
--   dos message box function
--pos = upper left corner - {x,y}
--bsize = message box size - {width,height}
--message = sequence of message lines - {"Line 1",Line 2"}
--bnum = sequence of button ID numbers to assign - {3,4}
--labels = sequence of button labels - {"OK","Cancel"}
--  message and buttons automatically centered and sized 
--  background automatically saved and restored
--  returns button number pressed
sequence sxy,exy,bpos,tmp,sscreen
integer spacing,width,tx,ty,test
bpos={}
if length(bnum)>0 then
spacing=floor((bsize[1]/(length(bnum)+1)))
for c=1 to length(bnum) do
tmp={length(labels[c])*8+16,24}
width=floor(tmp[1]/2)
bpos=append(bpos,{pos[1]+spacing*c-width,
floor(pos[2]+bsize[2]-36)})
end for
end if
sxy=pos
exy=pos+bsize
mouse_pointer(0)
sscreen=save_image(pos,pos+bsize)
box(shadow,sxy,exy)
box(highlight,sxy+1,exy-1)    
polygon(button_color,1,{sxy+2,{exy[1]-2,sxy[2]+2},exy-2,{sxy[1]+2,exy[2]-2}})
if length(bnum)>0 then
for c=1 to length(bnum) do
tmp={length(labels[c])*8+16,24}
set_size(tmp)
make_button(bnum[c],labels[c],bpos[c])
end for
end if
for c=1 to length(message) do
timage=build_text_image(message[c],txt_color,button_color,0)
tx=pos[1]+floor((bsize[1]-length(message[c])*8)/2)
ty=pos[2]+floor((bsize[2]-36)/(length(message)+1))*c-8
display_image({tx,ty},timage)
end for
mouse_pointer(1)
test=wait_button_down(bnum)
mouse_pointer(0)
display_image(pos,sscreen)
mouse_pointer(1)
return test
end function

global function gbox()  --name entry box
sequence sxy,exy,chars,sscreen
integer key,tx
tx=240
sxy={224,200}
exy={416,280}
mouse_pointer(0)
sscreen=save_image(sxy,exy)
box(shadow,sxy,exy)
box(highlight,sxy+1,exy-1)    
polygon(button_color,1,{sxy+2,{exy[1]-2,sxy[2]+2},exy-2,{sxy[1]+2,exy[2]-2}})
polygon(0,1,{{240,248},{400,248},{400,264},{240,264}})
chars={}
timage=build_text_image("Please enter your name",txt_color,button_color,0)
display_image({232,216},timage)
while 1 do
key=wait_key()
if key=13 then exit end if
if key=8 then
if tx>240 then
tx-=8 
timage=build_text_image({' '},7,0,0)
display_image({tx,248},timage)
chars=chars[1..length(chars)-1]
end if
end if
if key=32 or (key>65 and key<123) then
chars=chars&key
timage=build_text_image({key},7,0,0)
display_image({tx,248},timage)
tx=tx+8
end if
if length(chars)=20 then exit end if
end while
display_image(sxy,sscreen)
mouse_pointer(1)
return chars
end function

