--read ezip data - Paul Plummer

--  ezip data format  (n)=n bytes    example 2 entries

--(2)DS (1)length_file_name1 (?)file_name_string1 (1)ftype1 
--(4)Uncompressed_length1 (4)Compressed_length1 (?)compressed_data1
--(1)length_file_name2 (?)file_name_string2 (1)ftype2 (4)Uncompressed_length2 (4)Compressed_length
--(?)compressed_data2 (1)0 (4)total_length_of_data (2)DE

include machine.e
include get.e
include file.e
include zinflate.e


global sequence EZ_FILE,EZ_INFO
EZ_FILE={}  --path of program if bound
EZ_INFO={}

--retrives infomation on an ezip file
--must be called for a new ezip file to use ez_get()
--atomatically called at program startup for bound files
global function ez_info(sequence fname)
integer fn,file_pos,file_length,offset,junk,dat_start
sequence buffer,header,offsets
fn=open(fname,"rb")
if fn=-1 then
EZ_ERROR=14
return {}
end if  --open failed
junk=seek(fn,-1)
file_length=where(fn)
--? file_length
junk=seek(fn,file_length-6)
file_pos=file_length-6
buffer=get_bytes(fn,6)

if not(equal(buffer[5..6],"DE")) then
EZ_ERROR=15
close(fn)
return {}
end if
offset=bytes_to_int(buffer[1..4])  
dat_start= file_pos-offset
--close(fn)
junk=seek(fn,dat_start)
buffer=get_bytes(fn,2)
if not(equal(buffer,"DS")) then
EZ_ERROR=15
close(fn) 
return {}
end if
header={}

while 1 do
offsets={}
offset=getc(fn) 
if offset=-1 then 
EZ_ERROR=16
close(fn) 
return {}
end if
if offset=0 then exit end if
buffer=get_bytes(fn,offset+9)
file_pos=where(fn)-9
offsets&=file_pos  --offset
offsets&=buffer[length(buffer)-8] --ctype
offsets&=bytes_to_int(buffer[length(buffer)-7..length(buffer)-4])  --uncompressed
offset=bytes_to_int(buffer[length(buffer)-3..length(buffer)])  --compressed
offsets&=offset
buffer=buffer[1..length(buffer)-9]  --filename
buffer={buffer}
buffer=append(buffer,offsets)
header=append(header,buffer)
junk=seek(fn,file_pos+offset+9)
end while
close(fn)
EZ_INFO=header
EZ_FILE=fname
EZ_ERROR=0
return header --{{"filename1",{offset1,ctype1,ucomp1,comp1}},
--{"filename2",{offset2,ctype2...
end function

procedure ez_file()  --check a bound file for appended ezip data
sequence commands
commands=command_line()
if equal(commands[1],commands[2]) then
EZ_FILE=commands[2]    
EZ_INFO=ez_info(EZ_FILE)
end if
end procedure 

global function ez_get(sequence dname)  --read ezip data
integer test,fn,junk,offset,compressed,uncompressed,ctype
sequence buffer,output
if EZ_ERROR then
return {}    
end if
if length(EZ_INFO)=0 then
EZ_ERROR=17
return {}
end if
test=0
for c=1 to length(EZ_INFO) do
if equal(dname,EZ_INFO[c][1]) then
test=c
exit
end if
end for
if test then
  fn=open(EZ_FILE,"rb")
  if fn=-1 then
  EZ_ERROR=18
  return {}
  end if  --open failed
  offset=EZ_INFO[test][2][1]
  ctype=EZ_INFO[test][2][2]
  uncompressed=EZ_INFO[test][2][3]
  compressed=EZ_INFO[test][2][4]
  junk=seek(fn,offset)
  buffer=get_bytes(fn,compressed+9)
  output=inflate_seq(buffer)
if  EZ_ERROR then
close(fn)
return {}    
end if
    EZ_ERROR=0
close(fn)
    return  output
else
  EZ_ERROR=19

  return {}  --name not found
end if
end function

global function EZ_READ_ERROR_STRING()
if EZ_ERROR=0 then
return "No errors"
else
return EZ_ERROR_STRING[EZ_ERROR]    
end if
end function

global function EZ_READ_ERROR()
return EZ_ERROR    
end function

global procedure CLEAR_READ_ERROR()
EZ_ERROR=0    
end procedure

ez_file() 



