--creates compressed data requires zip16.exe used by ez_write.e
--creates a temporary zip file from which deflated data is extracted
-- dos32
--  A.  Local file header: zip format
--        local file header signature     4 bytes  (0x04034b50)   1 .. 4
--        version needed to extract       2 bytes                 5 6
--        general purpose bit flag        2 bytes                 7 8
--        compression method              2 bytes                 9 10
--        last mod file time              2 bytes                 11 12
--        last mod file date              2 bytes                 13 14
--        crc-32                          4 bytes                 15 .. 18
--        compressed size                 4 bytes                 19 .. 22
--        uncompressed size               4 bytes                 23 ..26
--        filename length                 2 bytes                 27 28
--        extra field length              2 bytes                 29 30
--        filename (variable size)
--        extra field (variable size)

include adler32.e
include file.e
include readfile.e
include get.e
include machine.e
include misc.e
include zd_bget.e
include ez_error.e
function get_word(sequence wdat)
return wdat[1]+256*wdat[2]    
end function


global function deflate_seq(sequence inseq,integer ftype)
--ftype 0=filename 1=sequence  2=sequence of bytes
--returns ctype+uncompressed length&compressed length&compressed sequence
--  length = 9 bytes + length compressed data
--                     or
--           returns {}
sequence adler
object tdir
integer fn,test
integer l_extra,l_name,comp,ctype,junk_key
sequence seq,head,junk,header,fname
header={}
tdir=dir("$$$.zip")
--if ftype=1 then
if sequence(tdir) then
  system("del $$$.zip",2) 
end if
tdir=dir("$$$.dat")
--if ftype=1 then
if sequence(tdir) then
  system("del $$$.dat",2) 
end if
if ftype then
if ftype=1 then
fn=open("$$$.dat","wb")
zd_bprint(fn,inseq)
close(fn)
fname="$$$.dat"
adler=adler_32(read_file(fname))
elsif ftype=2 then
if string8(inseq) then
adler=adler_32(inseq)
fn=open("$$$.dat","wb")
puts(fn,inseq)
close(fn)
fname="$$$.dat"
else
EZ_ERROR=30
return {}
end if
end if
else
fname=inseq    
adler=adler_32(read_file(fname))
end if
tdir=dir(fname)
if atom(tdir) then
EZ_ERROR=9
return {}    
end if
test=platform()
if test=DOS32 then
  test=system_exec("zip16 -q $$$ "&fname,2)
end if
if test=WIN32 then
puts(1,"Use ez_write.ew for WIN32 programs/n")
puts(1,"Press any key to exit/n")
junk_key=wait_key()
abort(1)
end if

  if test then
    EZ_ERROR=10
    return {}
  end if
--end if
fn=open("$$$.zip","rb")
if fn=-1 then
EZ_ERROR=11
return {}
end if
head=get_bytes(fn,30)      --read header
comp=bytes_to_int(head[19..22])
--ucomp=bytes_to_int(head[23..26])
ctype=get_word(head[9..10])
l_name=get_word(head[27..28])
l_extra=get_word(head[29..30])
junk=get_bytes(fn,l_name+l_extra)    --discard
if ctype=0 or ctype=8 then
if ctype=8 then
ctype=1    
end if
else
EZ_ERROR=12
return {} --unsupported compression method    
end if
if ftype=1 then
ctype+=2  --bget format  
end if
seq=ctype&head[23..26]&int_to_bytes(comp+4)&get_bytes(fn,comp)&adler
--ctype=0 uncompressed bytes
--ctype=1 compressed bytes
--ctype=2 uncompressed bget format
--ctype=3 compressed bget format
close(fn)
system("del $$$.zip",2) 
if ftype then
system("del $$$.dat",2)    
end if
EZ_ERROR=0
return seq
end function


